Codeforces Round #375 (Div. 2) E One-Way Reform(欧拉路径

题目链接

E. One-Way Reform

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

There are n cities and m two-way roads in Berland, each road connects two cities. It is known that there is no more than one road connecting each pair of cities, and there is no road which connects the city with itself. It is possible that there is no way to get from one city to some other city using only these roads.

The road minister decided to make a reform in Berland and to orient all roads in the country, i.e. to make each road one-way. The minister wants to maximize the number of cities, for which the number of roads that begins in the city equals to the number of roads that ends in it.

Input

The first line contains a positive integer t (1 ≤ t ≤ 200) — the number of testsets in the input.

Each of the testsets is given in the following way. The first line contains two integers n and m (1 ≤ n ≤ 200, 0 ≤ m ≤ n·(n - 1) / 2) — the number of cities and the number of roads in Berland.

The next m lines contain the description of roads in Berland. Each line contains two integers u and v (1 ≤ u, v ≤ n) — the cities the corresponding road connects. It's guaranteed that there are no self-loops and multiple roads. It is possible that there is no way along roads between a pair of cities.

It is guaranteed that the total number of cities in all testset of input data doesn't exceed 200.

Pay attention that for hacks, you can only use tests consisting of one testset, so t should be equal to one.

Output

For each testset print the maximum number of such cities that the number of roads that begins in the city, is equal to the number of roads that ends in it.

In the next m lines print oriented roads. First print the number of the city where the road begins and then the number of the city where the road ends. If there are several answers, print any of them. It is allowed to print roads in each test in arbitrary order. Each road should be printed exactly once.

Example

input

2
5 5
2 1
4 5
2 3
1 3
3 5
7 2
3 7
4 2

output

3
1 3
3 5
5 4
3 2
2 1
3
2 4
3 7

题意:

n个点m条边的无向连通图 
没有自环没有重边 
我们要把所有点都定向 
希望使得尽可能多的点拥有相同的入度与出度 
让你输出满足这个条件的最大点数和每条边最后的定向 

题解:

首先计算所有点的度,如果存在度为奇数的点,那么这种点的个数必定为偶数(因为由于每条边在度数总和上增加2,那么所以奇数度的点的度只和也必定为奇数),那么我们新建一个结点n+1,将那些度为奇数的点连向n+1。那么这个此时这个图每个点度都为偶数了,必定有欧拉回路,使用Fleury算法画欧拉路就可以了。

另外要注意图可能不连通,所以要对每个点进行dfs。

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<vector>
#include<set>
using namespace std;
const int MAXN=200+100;
set<int> g[MAXN];
int deg[MAXN];
vector<pair<int,int> >res;
int n,m;
void init()
{
	memset(deg,0,sizeof(deg));
	for(int i=0;i<MAXN;i++) g[i].clear();
	res.clear();
}
void dfs(int u)
{
	while(g[u].size())
	{
		int v=*g[u].begin();
		g[u].erase(v),g[v].erase(u);
		if(u!=n+1&&v!=n+1)
		 printf("%d %d\n",u,v);
		dfs(v);
	}
}
int main()
{
	int cas;
	scanf("%d",&cas);
	while(cas--)
	{
		init();
		scanf("%d%d",&n,&m);
		while(m--)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			g[u].insert(v),g[v].insert(u);
			deg[u]++,deg[v]++;
		}
		int ans=0;
		for(int i=1;i<=n;i++)
		if(deg[i]&1) ans++,g[i].insert(n+1),g[n+1].insert(i);
		printf("%d\n",n-ans);
		for(int i=1;i<=n;i++) dfs(i);
		
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/c_czl/article/details/82976217
今日推荐